const app = getApp()

import {
    repairRemindListRq,
    repairRemindReadRq
} from "../../../api/repair/repair.js"



Page({

    /**
     * 页面的初始数据
     */
    data: {
        IMG_NAME: app.IMG_NAME,
        // info
        info: {
            pageNum: 1,
            pageSize: 10,
            dataList: [],
            isDataAll: false,
        },
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        
    },

    // 获取数据
    getDataList() {
        let _this = this;

        // 获取参数
        let pageNum = null
        let pageSize = null
        let type = null
        let isDataAll = null

        let info = _this.data.info
        //
        pageNum = info.pageNum
        pageSize = info.pageSize
        isDataAll = info.isDataAll

        // 判断数据是否已全部加载
        if (isDataAll) {
            return;
        }
        // 传递参数
        let param = {
            pageNum,
            pageSize,
        }
        // 查询数据        
        repairRemindListRq(param).then(res => {
            console.log('repairRemindListRq', res);
            let dataList = res.rows
            let isDataAll = false
            if (pageNum * pageSize >= res.total) {
                isDataAll = true
            }
            //
            info.dataList = info.dataList.concat(_this.formartData(dataList))
            info.pageNum = info.pageNum + 1
            info.isDataAll = isDataAll
            _this.setData({
                info
            })
        })
    },

    // 格式化数据
    formartData(dataList) {
        // 格式化数据
        return dataList.map(item => {
            return item;
        })
    },

    jumpInfoDetail(e) {
        console.log('detail', e);
        let id = e.currentTarget.dataset.obj.id
        let repairId = e.currentTarget.dataset.obj.repairId
        repairRemindReadRq({
            id
        }).then(res => {
            wx.navigateTo({
                url: `/pages/reportRepair/assign/detail/detail?id=${repairId}`,
            })
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        let _this = this;
        _this.setData({
            info: {
                pageNum: 1,
                pageSize: 10,
                dataList: [],
                isDataAll: false,
            }
        })
        //
        _this.getDataList()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        console.log('onReachBottom', '页面上拉触底事件的处理函数');
        let _this = this;
        // 获取数据
        _this.getDataList()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})