const app = getApp()

import Notify from '@vant/weapp/notify/notify';

import {
    repairListRq,
    getQueryStatusName
} from "../../../../api/repair/repair.js"


Page({

    /**
     * 页面的初始数据
     */
    data: {
        // tabBar param
        tabBarParam: {
            selected: 0,
            color: "#515151",
            selectedColor: "#217CFF",
            backgroundColor: "#ffffff",
        },
        // tabBar menu
        tabBarList: [{
                "pagePath": "/pages/index/index",
                "iconPath": "/images/tabbar/home.png",
                "selectedIconPath": "/images/tabbar/home-select.png",
                "text": "首页"
            },
            {
                "pagePath": "/pages/reportRepair/report/report",
                "iconPath": "/images/tabbar/center.png",
                "selectedIconPath": "/images/tabbar/center.png",
                "text": "报修",
                "bulge": true,
            },
            {
                "pagePath": "/pages/my/my",
                "iconPath": "/images/tabbar/my.png",
                "selectedIconPath": "/images/tabbar/my-select.png",
                "text": "我的"
            },
        ],
        IMG_NAME: app.IMG_NAME,
        userData: null,
        dataChange: false,
        tabTitle: '全部',
        // 全部
        allOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'all',
            dataList: [],
            isDataAll: false,
        },
        // 处理中
        processOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'process',
            dataList: [],
            isDataAll: false,
        },
        // 待评价
        evalingOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'evaling',
            dataList: [],
            isDataAll: false,
        },
        // 已评价
        evaledOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'evaled',
            dataList: [],
            isDataAll: false,
        },
        //无效申请 
        invalidOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'invalid',
            dataList: [],
            isDataAll: false,
        },
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let _this = this;
        _this.setData({
            userData: wx.getStorageSync('user'),
        })
        // 获取数据
        let userId = _this.data.userData.id
    },

    // 切换tabbar
    switchTab(e) {
        const data = e.currentTarget.dataset
        console.log('switchTab', data)
        const url = data.path
        if (url == '/pages/reportRepair/report/report') {
            wx.navigateTo({
                url
            })
        } else {
            wx.switchTab({
                url
            })
        }
    },

    // tab 点击切换
    tabClickSwitch(event) {
        console.log('tabClickSwitch', event);
        let _this = this;
        _this.setData({
            tabTitle: event.detail.title
        })
    },

    // 获取数据
    getDataList(transferTabTitle) {
        // 获取参数
        let _this = this;
        let tabTitle = _this.data.tabTitle
        if (transferTabTitle) {
            tabTitle = transferTabTitle
        }
        let pageNum = null
        let pageSize = null
        let type = null
        let isDataAll = null

        //
        let allOrder = _this.data.allOrder
        let processOrder = _this.data.processOrder
        let evalingOrder = _this.data.evalingOrder
        let evaledOrder = _this.data.evaledOrder
        let invalidOrder = _this.data.invalidOrder

        if (tabTitle == '全部') {
            pageNum = allOrder.pageNum
            pageSize = allOrder.pageSize
            type = allOrder.type
            isDataAll = allOrder.isDataAll

        } else if (tabTitle == '处理中') {
            pageNum = processOrder.pageNum
            pageSize = processOrder.pageSize
            type = processOrder.type
            isDataAll = processOrder.isDataAll

        } else if (tabTitle == '待评价') {
            pageNum = evalingOrder.pageNum
            pageSize = evalingOrder.pageSize
            type = evalingOrder.type
            isDataAll = evalingOrder.isDataAll

        } else if (tabTitle == '已评价') {
            pageNum = evaledOrder.pageNum
            pageSize = evaledOrder.pageSize
            type = evaledOrder.type
            isDataAll = evaledOrder.isDataAll

        } else if (tabTitle == '无效单') {
            pageNum = invalidOrder.pageNum
            pageSize = invalidOrder.pageSize
            type = invalidOrder.type
            isDataAll = invalidOrder.isDataAll

        } else {
            wx.showToast({
                title: `tab 切换错误(${tabTitle})`,
                icon: 'none',
            });
            return;
        }

        // 判断数据是否已全部加载
        if (isDataAll) {
            return;
        }
        // 传递参数
        let param = {
            pageNum,
            pageSize,
            menu: '1', // 报修
            type,
        }
        // 查询数据        
        repairListRq(param).then(res => {
            console.log('repairListRq', res);
            let dataList = res.rows
            let isDataAll = false
            if (pageNum * pageSize >= res.total) {
                isDataAll = true
            }
            //
            if (tabTitle == '全部') {
                allOrder.dataList = allOrder.dataList.concat(_this.formartData(dataList))
                allOrder.pageNum = allOrder.pageNum + 1
                allOrder.isDataAll = isDataAll
                _this.setData({
                    allOrder
                })

            } else if (tabTitle == '处理中') {
                processOrder.dataList = processOrder.dataList.concat(_this.formartData(dataList))
                processOrder.pageNum = processOrder.pageNum + 1
                processOrder.isDataAll = isDataAll
                _this.setData({
                    processOrder
                })

            } else if (tabTitle == '待评价') {
                evalingOrder.dataList = evalingOrder.dataList.concat(_this.formartData(dataList))
                evalingOrder.pageNum = evalingOrder.pageNum + 1
                evalingOrder.isDataAll = isDataAll
                _this.setData({
                    evalingOrder
                })

            } else if (tabTitle == '已评价') {
                evaledOrder.dataList = evaledOrder.dataList.concat(_this.formartData(dataList))
                evaledOrder.pageNum = evaledOrder.pageNum + 1
                evaledOrder.isDataAll = isDataAll
                _this.setData({
                    evaledOrder
                })

            } else if (tabTitle == '无效单') {
                invalidOrder.dataList = invalidOrder.dataList.concat(_this.formartData(dataList))
                invalidOrder.pageNum = invalidOrder.pageNum + 1
                invalidOrder.isDataAll = isDataAll
                _this.setData({
                    invalidOrder
                })

            }

        })
    },

    // 格式化数据
    formartData(dataList) {
        // 格式化数据
        return dataList.map(item => {
            let ext1 = item.ext1
            if (ext1) {
                item.visibleImg = ext1
            } else {
                item.visibleImg = '/profile/static/repair/index/noneImg.png'
            }
            item.statusName = getQueryStatusName(item.status)
            return item;
        })
    },

    jumpDetail(e) {
        console.log('jumpDetail', e);
        let obj = e.currentTarget.dataset.obj
        wx.navigateTo({
            url: `/pages/reportRepair/assign/detail/detail?id=${obj.id}`,
        })
    },

    jumpEvaluate(e) {
        console.log('jumpEvaluate', e);
        let obj = e.currentTarget.dataset.obj
        wx.navigateTo({
            url: `/pages/reportRepair/assign/evaluate/evaluate?id=${obj.id}&back=1`,
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        let _this = this;
        _this.setData({
            // 全部
            allOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'all',
                dataList: [],
                isDataAll: false,
            },
            // 处理中
            processOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'process',
                dataList: [],
                isDataAll: false,
            },
            // 待评价
            evalingOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'evaling',
                dataList: [],
                isDataAll: false,
            },
            // 已评价
            evaledOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'evaled',
                dataList: [],
                isDataAll: false,
            },
            //无效申请 
            invalidOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'invalid',
                dataList: [],
                isDataAll: false,
            },
        })
        //
        _this.getDataList('全部')
        _this.getDataList('处理中')
        _this.getDataList('待评价')
        _this.getDataList('已评价')
        _this.getDataList('无效单')
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        console.log('onPullDownRefresh', '页面相关事件处理函数--监听用户下拉动作');

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        console.log('onReachBottom', '页面上拉触底事件的处理函数');
        let _this = this;
        // 获取数据
        _this.getDataList()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage(e) {
        console.log('onShareAppMessage', e);
        let _this = this;
        let obj = e.target.dataset.obj
        //
        let param = {
            title: obj.repairName,
            path: `/pages/reportRepair/assign/detail/detail?id=${obj.id}`,
            imageUrl: app.IMG_NAME + obj.visibleImg,
        }
        console.log('onShareAppMessage', param);
        return param;
    }
})