const app = getApp()

import {
    selfFormatTimeYMD,
    selfFormatTimeHM,
    checkIsImg
} from "../../../../utils/util.js"


import {
    repairListRq,
    workerRepairNumberRq
} from "../../../../api/repair/repair.js"

Page({

    /**
     * 页面的初始数据
     */
    data: {
          // tabBar param
          tabBarParam: {
            selected: 0,
            color: "#515151",
            selectedColor: "#217CFF",
            backgroundColor: "#ffffff",
        },
        // tabBar menu
        tabBarList: [{
                "pagePath": "/pages/index/index",
                "iconPath": "/images/tabbar/home.png",
                "selectedIconPath": "/images/tabbar/home-select.png",
                "text": "首页"
            },
            {
                "pagePath": "/pages/reportRepair/report/report",
                "iconPath": "/images/tabbar/center.png",
                "selectedIconPath": "/images/tabbar/center.png",
                "text": "报修",
                "bulge": true,
            },
            {
                "pagePath": "/pages/my/my",
                "iconPath": "/images/tabbar/my.png",
                "selectedIconPath": "/images/tabbar/my-select.png",
                "text": "我的"
            },
        ],
        IMG_NAME: app.IMG_NAME,
        workerNumber: {},
        tabTitle: 'wait', // tab 标题
        // 待完成
        waitOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'wait',
            dataList: [],
            isDataAll: false,
        },
        // 进行中
        workOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'working',
            dataList: [],
            isDataAll: false,
        },
        // 已完成
        closeOrder: {
            pageNum: 1,
            pageSize: 10,
            type: 'close',
            dataList: [],
            isDataAll: false,
        },
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let _this = this;
    },

    // 切换tabbar
    switchTab(e) {
        const data = e.currentTarget.dataset
        console.log('switchTab', data)
        const url = data.path
        if (url == '/pages/reportRepair/report/report') {
            wx.navigateTo({
                url
            })
        } else {
            wx.switchTab({
                url
            })
        }
    },

    back() {
        wx.navigateBack()
    },

    // tab 点击切换
    tabClickSwitch(e) {
        console.log('tabClickSwitch', e);
        let _this = this;
        _this.setData({
            tabTitle: e.target.dataset.type
        })
    },

    // 获取数据
    getDataList(transferTabTitle) {
        // 获取参数
        let _this = this;
        let tabTitle = _this.data.tabTitle
        if (transferTabTitle) {
            tabTitle = transferTabTitle
        }
        let pageNum = null
        let pageSize = null
        let type = null
        let isDataAll = null

        //
        let waitOrder = _this.data.waitOrder
        let workOrder = _this.data.workOrder
        let closeOrder = _this.data.closeOrder

        if (tabTitle == 'wait') {
            pageNum = waitOrder.pageNum
            pageSize = waitOrder.pageSize
            type = waitOrder.type
            isDataAll = waitOrder.isDataAll

        } else if (tabTitle == 'working') {
            pageNum = workOrder.pageNum
            pageSize = workOrder.pageSize
            type = workOrder.type
            isDataAll = workOrder.isDataAll

        } else if (tabTitle == 'close') {
            pageNum = closeOrder.pageNum
            pageSize = closeOrder.pageSize
            type = closeOrder.type
            isDataAll = closeOrder.isDataAll

        } else {
            wx.showToast({
                title: `tab 切换错误(${tabTitle})`,
                icon: 'none',
            });
            return;
        }

        // 判断数据是否已全部加载
        if (isDataAll) {
            return;
        }
        // 传递参数
        let param = {
            pageNum,
            pageSize,
            menu: '5', // 维修
            type,
        }
        // 查询数据        
        repairListRq(param).then(res => {
            console.log('repairListRq', res);
            let dataList = res.rows
            let isDataAll = false
            if (pageNum * pageSize >= res.total) {
                isDataAll = true
            }
            //
            if (tabTitle == 'wait') {
                waitOrder.dataList = waitOrder.dataList.concat(_this.formartData(dataList))
                waitOrder.pageNum = waitOrder.pageNum + 1
                waitOrder.isDataAll = isDataAll
                _this.setData({
                    waitOrder
                })

            } else if (tabTitle == 'working') {
                workOrder.dataList = workOrder.dataList.concat(_this.formartData(dataList))
                workOrder.pageNum = workOrder.pageNum + 1
                workOrder.isDataAll = isDataAll
                _this.setData({
                    workOrder
                })

            } else if (tabTitle == 'close') {
                closeOrder.dataList = closeOrder.dataList.concat(_this.formartData(dataList))
                closeOrder.pageNum = closeOrder.pageNum + 1
                closeOrder.isDataAll = isDataAll
                _this.setData({
                    closeOrder
                })

            }
        })
    },

    // 格式化数据
    formartData(dataList) {
        // 格式化数据
        return dataList.map(item => {
            return item;
        })
    },

    // 跳转
    jumpCase(e) {
        console.log('jumpCase', e);
        let id = e.currentTarget.dataset.obj.id
        wx.navigateTo({
            url: `/pages/reportRepair/repair/case/case?id=${id}`,
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        let _this = this;
        _this.setData({
            // 待完成
            waitOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'wait',
                dataList: [],
                isDataAll: false,
            },
            // 进行中
            workOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'working',
                dataList: [],
                isDataAll: false,
            },
            // 已完成
            closeOrder: {
                pageNum: 1,
                pageSize: 10,
                type: 'close',
                dataList: [],
                isDataAll: false,
            },
        })
        // 数据
        _this.getDataList('wait')
        _this.getDataList('working')
        _this.getDataList('close')

        // 获取维修人员工单数量统计
        workerRepairNumberRq().then(res => {
            console.log('workerRepairNumberRq', res);
            _this.setData({
                workerNumber: res.workerRepairNumber
            })
        })
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        console.log('onReachBottom');
        let _this = this
        _this.getDataList()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})